////////////////////////////////
//
// TS_SDynamicBlock.h
//
//  1994, 1995, 1996, 1997 Tangent Systems
//
// All rights reserved.
//
// This file contains confidential and proprietary information. No Portion
// of this file may be reproduced, by any means, without the written
// permission of Tangent Systems
//
// Tangent Systems makes no representation or warranties about the suitibility of the software,
// either express or implied, including but not limited to the implied warranties of merchantability,
// fitness for a particular purpose, or non-infringment.
//
// Description:

//
//
// Author: John H. Shackelford, Tangent Systems
// email: jshack@tangentsys.com
//
// Date: 1997/06/20
// Version: A
//
// Revision History:
// 1997/06/20 Revision A - 	Initial Release
//
////////////////////////////////	
	
#ifndef _TS_SDynamicBlock_h
#define _TS_SDynamicBlock_h

#include "TSBuildBlock.h"
#include "BSMath.h"

typedef struct
{
	int Row;
	int Col;
} MatDim;

class TS_SDynamicBlock : public TSBuildBlock
{
public:
// Attributes
	MatDim	ADim;	// [Row, Columns]
	MatDim 	BDim;	// [Row, Columns]
	MatDim	CDim;	// [Row, Columns]
	MatDim	DDim;	// [Row, Columns]
	int SDim;		// length
	int IDim;		// length
	RealMatrix AMatrix;
	RealMatrix BMatrix;
	RealMatrix CMatrix;
	RealMatrix DMatrix;
	RealVector AX;
	RealVector BU;
	RealVector CX;
	RealVector DU;
	RealVector StateVector;
	RealVector StateDot;
	RealVector IStateVector;
	RealVector InputVector;
	RealVector OutputVector;

// Methods
	TS_SDynamicBlock();
	int doSimulate(Real time);
	virtual void setupSystemMatrices();
			
};
#endif